<template>
  <close-content v-show="loadingGroups || selectedGroups.length > 0">
    <template #title>
      {{
        $gettext('Popular groups nearby %{position}', {
          position: userLocation.name,
        })
      }}
    </template>
    <template #content>
      <skeleton-group-result
        v-for="i in [...Array(6).keys()]"
        class="scroll-ml-6 snap-center shrink-0 w-[18rem] my-4"
        :key="i"
        v-show="loadingGroups"
      />
      <group-result
        v-for="group in selectedGroups"
        :key="group.id"
        class="scroll-ml-6 snap-center shrink-0 first:pl-8 last:pr-8 w-[18rem]"
        :group="group"
        :view-mode="'column'"
        :minimal="true"
        :has-border="true"
      />

      <more-content
        :to="{
          name: 'SEARCH',
          query: {
            locationName: userLocation.name,
            lat: userLocation.lat,
            lon: userLocation.lon,
            contentType: 'GROUPS',
            distance: currentDistance,
          },
        }"
        :picture="userLocation.picture"
      >
        {{
          $gettext('View more groups around %{position}', {
            position: userLocation.name,
          })
        }}
      </more-content>
    </template>
  </close-content>
</template>

<script lang="ts" setup>
  import { buildGroupSearchQuery } from '../../query/buildQuery'
  import { useGettext } from 'vue3-gettext'
  import { searchGroups } from '../../shared/search'
  import { inject, reactive, computed, ref, watchEffect } from 'vue'
  import { ResultList } from '../../../../server/types/search-query/common-search.model'
  import GroupResult from '../../components/result/GroupResult.vue'
  import SkeletonGroupResult from '../../components/result/SkeletonGroupResult.vue'
  import { EnhancedGroup } from '../../../../server/types/group.model'
  import { sampleSize } from 'lodash'
  import { LocationType } from '../../../../shared/user-location.model'
  import MoreContent from './MoreContent.vue'
  import CloseContent from './CloseContent.vue'
  import { closest } from '@/shared/utils'

  const { $gettext } = useGettext()

  const { userLocation } = inject<{
    userLocation: LocationType
  }>('userLocation')

  const groups = reactive<ResultList<EnhancedGroup>>({
    total: 0,
    data: [],
  })

  const selectedGroups = computed(() => sampleSize(groups.data, 5))

  const loadingGroups = ref(true)

  const currentDistance = ref('25_km')

  const fetchCloseGroups = async (
    location: { lat: number; lon: number },
    distanceLevel = 0
  ) => {
    let distance = 25

    console.debug('userLocation', userLocation)

    distance = closest(userLocation.accuracy, [5, 10, 25, 50, 100, 150])

    console.debug('fetchCloseGroups with distance level', distanceLevel)
    currentDistance.value = `${distance}_km`
    const query = buildGroupSearchQuery(
      {
        locationData: userLocation,
        page: 1,
        resultsPerGroupPage: 5,
        distance: currentDistance.value,
      },
      $gettext
    )

    const fetchedGroups = await searchGroups(query)
    // if (fetchedGroups.data.length < 5 && distanceLevel + 1 < distances.exact.length) {
    //   return fetchCloseGroups(location, distanceLevel + 1)
    // }
    return fetchedGroups
  }

  watchEffect(async () => {
    const fetchedGroups = await fetchCloseGroups(userLocation)
    groups.total = fetchedGroups.total
    groups.data = fetchedGroups.data
    loadingGroups.value = false
  })
</script>
